<?php

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

function eme_new_country() {
   $country = array(
   'alpha_2' => '',
   'alpha_3' => '',
   'num_3' => '',
   'name' => '',
   'locale' => ''
   );
   return $country;
}

function eme_new_state() {
   $state = array(
   'code' => '',
   'name' => '',
   'country_id' => 0
   );
   return $state;
}

function eme_countries_page() {      
   
   if (!current_user_can( get_option('eme_cap_settings')) && (isset($_GET['eme_admin_action']) || isset($_POST['eme_admin_action']))) {
      $message = __('You have no right to manage discounts!','events-made-easy');
      eme_countries_main_layout($message);
      return;
   }
  
   $message = '';
   $csvMimes = array('text/x-comma-separated-values', 'text/comma-separated-values', 'application/octet-stream', 'application/vnd.ms-excel', 'application/x-csv', 'text/x-csv', 'text/csv', 'application/csv', 'application/excel', 'application/vnd.msexcel', 'text/plain');

   // handle possible ations
   if (isset($_POST['eme_admin_action'])) {
      check_admin_referer('eme_countries','eme_admin_nonce');
      if ($_POST['eme_admin_action'] == "do_importcountries" && isset($_FILES['eme_csv']) && current_user_can(get_option('eme_cap_cleanup'))) {
	 $inserted=0;
	 $errors=0;
	 $error_msg='';
	 //validate whether uploaded file is a csv file
         if (!empty($_FILES['eme_csv']['name']) && in_array($_FILES['eme_csv']['type'],$csvMimes)) {
		 if (is_uploaded_file($_FILES['eme_csv']['tmp_name'])) {
			 $handle = fopen($_FILES['eme_csv']['tmp_name'], "r");
			 // first line is the column headers
			 $headers = array_map('strtolower', fgetcsv($handle));
			 // check required columns
			 if (!in_array('alpha_2',$headers)||!in_array('name',$headers)) {
				 $message = __("Not all required fields present.",'events-made-easy');
			 } else {
				 while (($row = fgetcsv($handle)) !== FALSE) {
					 $country = array_combine($headers, $row);
					 $res = eme_db_insert_country($country);
					 if ($res) {
						 $inserted++;
					 } else {
						 $errors++;
						 $error_msg.='<br />'.eme_esc_html(sprintf(__('Not imported: %s','events_made_easy'),implode(',',$row)));
					 }
				 }
				 $message = sprintf(__('Import finished: %d inserts, %d errors','events_made_eady'),$inserted,$errors);
				 if ($errors) $message.='<br />'.$error_msg;
			 }
			 fclose($handle);
		 } else {
			 $message = __('Problem detected while uploading the file','events_made_eady');
		 }
	 } else {
		 $message = sprintf(__('No CSV file detected: %s','events_made_eady'),$_FILES['eme_csv']['type']);
	 }
      } elseif ($_POST['eme_admin_action'] == "do_importstates" && isset($_FILES['eme_csv']) && current_user_can(get_option('eme_cap_cleanup'))) {
	 $inserted=0;
	 $errors=0;
	 $error_msg='';
	 //validate whether uploaded file is a csv file
         if (!empty($_FILES['eme_csv']['name']) && in_array($_FILES['eme_csv']['type'],$csvMimes)) {
		 if (is_uploaded_file($_FILES['eme_csv']['tmp_name'])) {
			 $handle = fopen($_FILES['eme_csv']['tmp_name'], "r");
			 // first line is the column headers
			 $headers = array_map('strtolower', fgetcsv($handle));
			 // check required columns
			 if (!in_array('code',$headers)||!in_array('name',$headers)||!in_array('country_id',$headers)) {
				 $message = __("Not all required fields present.",'events-made-easy');
			 } else {
				 while (($row = fgetcsv($handle)) !== FALSE) {
					 $state = array_combine($headers, $row);
					 $res = eme_db_insert_state($state);
					 if ($res) {
						 $inserted++;
					 } else {
						 $errors++;
						 $error_msg.='<br />'.eme_esc_html(sprintf(__('Not imported: %s','events_made_easy'),implode(',',$row)));
					 }
				 }
				 $message = sprintf(__('Import finished: %d inserts, %d errors','events_made_eady'),$inserted,$errors);
				 if ($errors) $message.='<br />'.$error_msg;
			 }
			 fclose($handle);
		 } else {
			 $message = __('Problem detected while uploading the file','events_made_eady');
		 }
	 } else {
		 $message = sprintf(__('No CSV file detected: %s','events_made_eady'),$_FILES['eme_csv']['type']);
         }
      }
   }
   
   // now that we handled possible ations, let's show the wanted screen
   if (isset($_GET['eme_admin_action']) && $_GET['eme_admin_action'] == "countries") { 
      eme_manage_countries_layout($message);
      return;
   }
   if (isset($_GET['eme_admin_action']) && $_GET['eme_admin_action'] == "states") { 
      eme_manage_states_layout($message);
      return;
   }
   eme_countries_main_layout();
}

function eme_countries_main_layout($message='') {
   $nonce_field = wp_nonce_field('eme_countries','eme_admin_nonce',false,false);
   $countries_destination = admin_url("admin.php?page=eme-countries&amp;eme_admin_action=countries");
   $states_destination = admin_url("admin.php?page=eme-countries&amp;eme_admin_action=states");
   $html = "
      <div class='wrap nosubsub'>\n
         <div id='icon-edit' class='icon32'>
            <br />
         </div>
         <h1>".__('Manage countries and states', 'events-made-easy')."</h1>
   ";
   if (!empty($message)) {
           $html .= '<div id="countries-message" style="background-color: rgb(255, 251, 204);"><p>'.$message.'</p></div>';
   }

   $html .= "<p>".__('For personal info (people, members, event rsvp) EME allows you to use auto-completion on states, based on the country choice. However, since there are way too many states and languages, it is impossible to provide that list in EME itself. So if you want to use country and state info, you should enter the countries and states here.','events-made-easy')."</p>";

   $html .= "<p><b>".__('This is NOT used for event locations, only for personal info of people.', 'events-made-easy')."</b></p>";
   $html .= "<h2>".__('Manage countries', 'events-made-easy')."</h2>";
   $html .= "<a href='$countries_destination'>".__("Manage countries",'events-made-easy')."</a><br />";
   $html .= "<h2>".__('Manage states', 'events-made-easy')."</h2>";
   $countries_count=eme_get_countries_count();
   if ($countries_count>0)
	   $html .= "<a href='$states_destination'>".__("Manage states",'events-made-easy')."</a><br />";
   else
	   $html .= __("There are no countries defined yet. First define some countries, then you can manage the states.",'events-made-easy')."<br />";
   echo $html;  
}

function eme_manage_countries_layout($message="") {
   $locale = get_locale();
   $nonce_field = wp_nonce_field('eme_countries','eme_admin_nonce',false,false);
   if (empty($message))
           $hidden_style="display:none;";
   else
           $hidden_style="";

   ?>
      <div class="wrap nosubsub">
       <div id="poststuff">
         <div id="icon-edit" class="icon32">
            <br />
         </div>
         
         <div id="countries-message" class="notice is-dismissible" style="background-color: rgb(255, 251, 204);<?php echo $hidden_style; ?>">
               <p><?php echo $message; ?></p>
         </div>

         <h1><?php _e('Countries', 'events-made-easy') ?></h1>

   <?php if (current_user_can(get_option('eme_cap_cleanup'))) { ?>
   <span class="eme_import_form_img">
   <?php _e('Click on the icon to show the import form','events-made-easy'); ?>
   <img src="<?php echo EME_PLUGIN_URL;?>images/showhide.png" class="showhidebutton" alt="show/hide" data-showhide="div_import" style="cursor: pointer; vertical-align: middle; ">
   </span>
   <div id='div_import' name='div_import' style='display:none;'>
   <form id='countries-import' method='post' enctype='multipart/form-data' action='#'>
   <?php echo $nonce_field; ?>
   <input type="file" name="eme_csv" />
   <input type="hidden" name="eme_admin_action" value="do_importcountries" />
   <input type="submit" value="<?php _e ( 'Import','events-made-easy'); ?>" name="doaction" id="doaction" class="button-primary action" />
   <?php _e('If you want, use this to import countries into the database', 'events-made-easy'); ?>
   </form>
   </div>
   <br />
   <?php echo sprintf(__('See <a href="%s">here</a> for more info on country codes', 'events-made-easy'),'https://en.wikipedia.org/wiki/ISO_3166-1'); ?>
   <br />
   <?php echo sprintf(__('The "locale" should correspond to one of the wordpress languages you want to support, or leave it empty as a default or fallback. The current wordpress locale is "%s".', 'events-made-easy'),$locale); ?>
   <br />
   <?php } ?>
   <br />
   <form id='countries-form' action="#" method="post">
   <?php echo $nonce_field; ?>
   <select id="eme_admin_action" name="eme_admin_action">
   <option value="" selected="selected"><?php _e ( 'Bulk Actions' , 'events-made-easy'); ?></option>
   <option value="deleteCountries"><?php _e ( 'Delete selected countries','events-made-easy'); ?></option>
   </select>
   <button id="CountriesActionsButton" class="button-secondary action"><?php _e ( 'Apply' , 'events-made-easy'); ?></button>
   <span class="rightclickhint">
      <?php _e('Hint: rightclick on the column headers to show/hide columns','events-made-easy'); ?>
   </span>
   <div id="CountriesTableContainer"></div>
   </form>
      </div> 
   </div>
   <?php
}

function eme_manage_states_layout($message="") {
   $nonce_field = wp_nonce_field('eme_countries','eme_admin_nonce',false,false);
   if (empty($message))
           $hidden_style="display:none;";
   else
           $hidden_style="";
   ?>
      <div class="wrap nosubsub">
       <div id="poststuff">
         <div id="icon-edit" class="icon32">
            <br />
         </div>
         
	 <div id="states-message" class="notice is-dismissible" style="background-color: rgb(255, 251, 204);<?php echo $hidden_style; ?>">
               <p><?php echo $message; ?></p>
         </div>

         <h1><?php _e('States', 'events-made-easy') ?></h1>

   <?php if (current_user_can(get_option('eme_cap_cleanup'))) { ?>
   <span class="eme_import_form_img">
   <?php _e('Click on the icon to show the import form','events-made-easy'); ?>
   <img src="<?php echo EME_PLUGIN_URL;?>images/showhide.png" class="showhidebutton" alt="show/hide" data-showhide="div_import" style="cursor: pointer; vertical-align: middle; ">
   </span>
   <div id='div_import' name='div_import' style='display:none;'>
   <form id='states-import' method='post' enctype='multipart/form-data' action='#'>
   <?php echo $nonce_field; ?>
   <input type="file" name="eme_csv" />
   <input type="hidden" name="eme_admin_action" value="do_importstates" />
   <input type="submit" value="<?php _e ( 'Import','events-made-easy'); ?>" name="doaction" id="doaction" class="button-primary action" />
   <?php _e('If you want, use this to import states into the database', 'events-made-easy'); ?>
   </form>
   </div>
   <br />
   <?php echo sprintf(__('See <a href="%s">here</a> for more info on state codes', 'events-made-easy'),'https://wikipedia.org/wiki/ISO_3166-2'); ?>
   <?php _e('The code should consist of 2 letters. An example would be the code "WA" for "Washington, US"', 'events-made-easy'); ?>
   <br />
   <?php } ?>
   <br />
   <form id='states-form' action="#" method="post">
   <?php echo $nonce_field; ?>
   <select id="eme_admin_action" name="eme_admin_action">
   <option value="" selected="selected"><?php _e ( 'Bulk Actions' , 'events-made-easy'); ?></option>
   <option value="deleteStates"><?php _e ( 'Delete selected states','events-made-easy'); ?></option>
   </select>
   <button id="StatesActionsButton" class="button-secondary action"><?php _e ( 'Apply' , 'events-made-easy'); ?></button>
   <span class="rightclickhint">
      <?php _e('Hint: rightclick on the column headers to show/hide columns','events-made-easy'); ?>
   </span>
   <div id="StatesTableContainer"></div>
   </form>
   </div> 
   </div>
   <?php
}

function eme_get_states($country_id=0) {
   global $wpdb;
   $table = $wpdb->prefix.STATES_TBNAME;
   $countries_table = $wpdb->prefix.COUNTRIES_TBNAME;
   $sql = "SELECT state.*,country.locale FROM $table as state LEFT JOIN $countries_table AS country ON state.country_id=country.id";
   return $wpdb->get_results($sql, ARRAY_A);
}
function eme_get_localized_states($country_code='') {
   global $wpdb;
   $table = $wpdb->prefix.STATES_TBNAME;
   $countries_table = $wpdb->prefix.COUNTRIES_TBNAME;
   $locale = get_locale();
   if (empty($country_code))
	   $sql = "SELECT state.*,country.name AS country,country.locale FROM $table as state LEFT JOIN $countries_table AS country ON state.country_id=country.id WHERE locale='$locale'";
   else
	   $sql = $wpdb->prepare("SELECT state.*,country.name AS country,country.locale FROM $table as state LEFT JOIN $countries_table AS country ON state.country_id=country.id WHERE country.alpha_2=%s AND country.locale='$locale'",$country_code);
   $res = $wpdb->get_results($sql, ARRAY_A);
   if (empty($res)) {
	   if (empty($country_code))
		   $sql = "SELECT state.*,country.name AS country,country.locale FROM $table as state LEFT JOIN $countries_table AS country ON state.country_id=country.id WHERE locale=''";
	   else
		   $sql = $wpdb->prepare("SELECT state.*,country.name AS country,country.locale FROM $table as state LEFT JOIN $countries_table AS country ON state.country_id=country.id WHERE country.alpha_2=%s AND country.locale=''",$country_code);
	   $res = $wpdb->get_results($sql, ARRAY_A);
   }
   return $res;
}

function eme_get_countries_count() {
   global $wpdb;
   $table = $wpdb->prefix.COUNTRIES_TBNAME;
   $sql = "SELECT count(*) FROM $table";
   return $wpdb->get_var($sql);
}
function eme_get_countries() {
   global $wpdb;
   $table = $wpdb->prefix.COUNTRIES_TBNAME;
   $sql = "SELECT * FROM $table";
   return $wpdb->get_results($sql, ARRAY_A);
}
function eme_get_localized_countries() {
   global $wpdb;
   $table = $wpdb->prefix.COUNTRIES_TBNAME;
   $locale = get_locale();
   $sql = "SELECT * FROM $table WHERE locale='$locale'";
   $res = $wpdb->get_results($sql, ARRAY_A);
   if (empty($res)) {
	   $sql = "SELECT * FROM $table WHERE locale=''";
	   $res = $wpdb->get_results($sql, ARRAY_A);
   }
   return $res;
}
function eme_get_countries_alpha2() {
   global $wpdb;
   $table = $wpdb->prefix.COUNTRIES_TBNAME;
   $sql = "SELECT alpha_2 FROM $table GROUP BY alpha_2";
   return $wpdb->get_col($sql);
}

function eme_db_insert_country($line) {
	global $wpdb;
	$table = $wpdb->prefix.COUNTRIES_TBNAME;

	$country=eme_new_country();
	// we only want the columns that interest us
	$keys=array_intersect_key($line,$country);
	$new_line=array_merge($country,$keys);

	if ($wpdb->insert($table,$new_line) === false) {
		return false;
	} else {
		return $wpdb->insert_id;
	}
}

function eme_db_update_country($id,$line) {
	global $wpdb;
	$table = $wpdb->prefix.COUNTRIES_TBNAME;
	$people_table = $wpdb->prefix.PEOPLE_TBNAME;

	// first get the existing country, compary the alpha_2 and change ALL countries and people from the old to new alpha_2 if not the same
	$country=eme_get_country($id);
	if ($country['alpha_2'] != $line['alpha_2']) {
		$sql = $wpdb->prepare("UPDATE $people_table SET country_code=%s WHERE country_code=%s",$line['alpha_2'],$country['alpha_2']); 
		$wpdb->query($sql);
		$sql = $wpdb->prepare("UPDATE $table SET alpha_2=%s WHERE alpha_2=%s",$line['alpha_2'],$country['alpha_2']); 
		$wpdb->query($sql);
	}
	if ($country['alpha_3'] != $line['alpha_3']) {
		$sql = $wpdb->prepare("UPDATE $table SET alpha_3=%s WHERE alpha_3=%s",$line['alpha_3'],$country['alpha_3']); 
		$wpdb->query($sql);
	}
	if ($country['num_3'] != $line['num_3']) {
		$sql = $wpdb->prepare("UPDATE $table SET num_3=%s WHERE num_3=%s",$line['num_3'],$country['num_3']); 
		$wpdb->query($sql);
	}

	// we only want the columns that interest us
	$keys=array_intersect_key($line,$country);
	$new_line=array_merge($country,$keys);
	$where = array ('id'=>$id);
	if (isset($new_line['id'])) unset($new_line['id']);
	if ($wpdb->update($table, $new_line, $where) === false) {
		return false;
	} else {
		return $id;
	}
}

function eme_db_insert_state($line) {
	global $wpdb;
	$table = $wpdb->prefix.STATES_TBNAME;

	$state=eme_new_state();
	// we only want the columns that interest us
	$keys=array_intersect_key($line,$state);
	$new_line=array_merge($state,$keys);
	if ($wpdb->insert($table,$new_line) === false) {
		return false;
	} else {
		return $wpdb->insert_id;
	}
}

function eme_db_update_state($id,$line) {
	global $wpdb;
	$table = $wpdb->prefix.STATES_TBNAME;
	$people_table = $wpdb->prefix.PEOPLE_TBNAME;

	// first get the existing state, compary the state code and change ALL relevant states and people from the old to new code if not the same
	$state=eme_get_state($id);
	if ($state['code'] != $line['code']) {
		$sql = $wpdb->prepare("UPDATE $people_table SET state_code=%s WHERE state_code=%s",$line['code'],$state['code']); 
		$wpdb->query($sql);
		$sql = $wpdb->prepare("UPDATE $table SET code=%s WHERE code=%s AND country_id=%d",$line['code'],$state['code'],$state['country_id']); 
		$wpdb->query($sql);
	}

	// we only want the columns that interest us
	$keys=array_intersect_key($line,$state);
	$new_line=array_merge($state,$keys);
	$where= array ('id'=>$id);
	if (isset($new_line['id'])) unset($new_line['id']);
	if ($wpdb->update($table, $new_line, $where) === false) {
		return false;
	} else {
		return $id;
	}
}

function eme_get_country($id) {
   global $wpdb;
   $table = $wpdb->prefix.COUNTRIES_TBNAME;
   $locale = get_locale();
   $sql = $wpdb->prepare("SELECT * FROM $table WHERE id = %d",$id);
   return $wpdb->get_row($sql, ARRAY_A);
}

function eme_get_country_name($code,$locale='') {
   global $wpdb;
   $table = $wpdb->prefix.COUNTRIES_TBNAME;
   if (empty($locale))
	   $locale = get_locale();
   $sql = $wpdb->prepare("SELECT name FROM $table WHERE alpha_2 = %s AND locale='$locale'",$code);
   $res = $wpdb->get_var($sql);
   if (empty($res)) {
	   $sql = $wpdb->prepare("SELECT name FROM $table WHERE alpha_2 = %s AND locale=''",$code);
	   $res = $wpdb->get_var($sql);
   }
   return $res;
}

function eme_get_state($id) {
   global $wpdb;
   $table = $wpdb->prefix.STATES_TBNAME;
   $sql = $wpdb->prepare("SELECT * FROM $table WHERE id=%d",$id);
   return $wpdb->get_row($sql, ARRAY_A);
}

function eme_get_state_locale($id) {
   global $wpdb;
   $table = $wpdb->prefix.STATES_TBNAME;
   $countries_table = $wpdb->prefix.COUNTRIES_TBNAME;
   $sql = $wpdb->prepare("SELECT country.locale FROM $table as state LEFT JOIN $countries_table AS country ON state.country_id=country.id WHERE state.id=%d",$id);
   return $wpdb->get_var($sql);
}

function eme_get_state_name($code,$country_code,$locale='') {
   global $wpdb;
   $table = $wpdb->prefix.STATES_TBNAME;
   $countries_table = $wpdb->prefix.COUNTRIES_TBNAME;
   if (empty($locale))
	   $locale = get_locale();
   $sql = $wpdb->prepare("SELECT state.name FROM $table as state LEFT JOIN $countries_table AS country ON state.country_id=country.id WHERE state.code=%s and country.alpha_2=%s AND (country.locale='' OR country.locale='$locale')",$code,$country_code);
   return $wpdb->get_var($sql);
}

add_action( 'wp_ajax_eme_countries_list', 'eme_ajax_countries_list' );
add_action( 'wp_ajax_eme_countries_options', 'eme_ajax_countries_options' );
add_action( 'wp_ajax_eme_manage_countries', 'eme_ajax_manage_countries' );
add_action( 'wp_ajax_eme_country_edit', 'eme_ajax_country_edit' );
add_action( 'wp_ajax_eme_states_list', 'eme_ajax_states_list' );
add_action( 'wp_ajax_eme_manage_states', 'eme_ajax_manage_states' );
add_action( 'wp_ajax_eme_state_edit', 'eme_ajax_state_edit' );

function eme_ajax_countries_list() {
   eme_ajax_record_list(COUNTRIES_TBNAME, 'eme_cap_settings');
}
function eme_ajax_countries_options() {
   global $wpdb;
   $table = $wpdb->prefix.COUNTRIES_TBNAME;
   $jTableResult = array();
   if (current_user_can( get_option('eme_cap_settings'))) {
	   // the option list in jtable needs "Value" and "DisplayText"
      // in case we are in the edit/create (and not list), we also show the locale
      if (!isset($_REQUEST['list']))
	      $sql="SELECT id AS Value, CONCAT (name, ' (', locale, ')') AS DisplayText FROM $table";
      else
	      $sql="SELECT id AS Value, name AS DisplayText FROM $table";
      $jTableResult['Result'] = "OK";
      $jTableResult['Options'] = $wpdb->get_results($sql, ARRAY_A);
   } else {
      $jTableResult['Result'] = "Error";
      $jTableResult['Message'] = __('Access denied!','events-made-easy');
   }
   print json_encode($jTableResult);
   wp_die();
}

function eme_ajax_states_list() {
   global $wpdb;
   $table = $wpdb->prefix.STATES_TBNAME;
   $countries_table = $wpdb->prefix.COUNTRIES_TBNAME;
   $jTableResult = array();
   if (current_user_can( get_option('eme_cap_settings'))) {
      $sql = "SELECT COUNT(*) FROM $table";
      $recordCount = $wpdb->get_var($sql);
      if (isset($_REQUEST["jtSorting"]) && !empty($_REQUEST["jtSorting"]))
              $sorting="ORDER BY ".esc_sql($_REQUEST["jtSorting"]);
      else
              $sorting="";
      if (isset($_REQUEST["jtStartIndex"]) && isset($_REQUEST["jtPageSize"]))
              $limit=" LIMIT ".intval($_REQUEST["jtStartIndex"]).",".intval($_REQUEST["jtPageSize"]);
      else
              $limit="";

      $sql = "SELECT state.*,country.locale FROM $table as state LEFT JOIN $countries_table AS country ON state.country_id=country.id $sorting $limit";
      $rows = $wpdb->get_results($sql, ARRAY_A);
      $jTableResult['Result'] = "OK";
      $jTableResult['TotalRecordCount'] = $recordCount;
      $jTableResult['Records'] = $rows;
   } else {
      $jTableResult['Result'] = "Error";
      $jTableResult['Message'] = __('Access denied!','events-made-easy');
   }
   print json_encode($jTableResult);
   wp_die();
}
function eme_ajax_manage_countries() {
   check_ajax_referer('eme_countries','eme_admin_nonce');
   if (!current_user_can( get_option('eme_cap_settings'))) {
      $jTableResult['Result'] = "Error";
      $jTableResult['Message'] = __('Access denied!','events-made-easy');
      print json_encode($jTableResult);
      wp_die();
   }
   if (isset($_REQUEST['do_action'])) {
     $do_action=eme_sanitize_request($_REQUEST['do_action']);
     switch ($do_action) {
         case 'deleteCountries':
              eme_ajax_country_delete();
              break;
      }
   }
   wp_die();
}
function eme_ajax_manage_states() {
   check_ajax_referer('eme_countries','eme_admin_nonce');
   if (isset($_REQUEST['do_action'])) {
     $do_action=eme_sanitize_request($_REQUEST['do_action']);
     switch ($do_action) {
         case 'deleteStates':
              eme_ajax_record_delete(STATES_TBNAME, 'eme_cap_settings', 'id');
              break;
      }
   }
   wp_die();
}
function eme_ajax_country_delete() {
   global $wpdb;
   $countries_table = $wpdb->prefix.COUNTRIES_TBNAME;
   $states_table = $wpdb->prefix.STATES_TBNAME;

   check_ajax_referer('eme_countries','eme_admin_nonce');
   $ids_arr=explode(',',$_POST['id']);
   if (eme_array_integers($ids_arr)) {
         $wpdb->query("DELETE FROM $countries_table WHERE id in ( ".$_POST['id'].")");
         $wpdb->query("UPDATE $states_table SET country_id=0 where country_id in ( ".$_POST['id'].")");
   }
   $jTableResult['Result'] = "OK";
   $jTableResult['Message'] = __('Country deleted!','events-made-easy');
   print json_encode($jTableResult);
   wp_die();
}

function eme_ajax_country_edit() {
   check_ajax_referer('eme_countries','eme_admin_nonce');
   $jTableResult = array();

   if (isset($_POST['id'])) {
      $country=eme_get_country(intval($_POST['id']));
      $update=1;
      if (!$country) {
	      $jTableResult['Result'] = "Error";
	      $jTableResult['Message'] = __("No such country",'events-made-easy');
	      print json_encode($jTableResult);
	      wp_die();
      }
   } else {
      $country=eme_new_country();
      $update=0;
   }
   foreach ($country as $key=>$val) {
      if (isset($_POST[$key]))
         $country[$key]=eme_strip_tags($_POST[$key]);
   }

   if (strlen($country['alpha_2']) != 2) {
	   $jTableResult['Result'] = "Error";
	   $jTableResult['Message'] = __("Incorrect alpha-2 code",'events-made-easy');
	   print json_encode($jTableResult);
	   wp_die();
   } else {
	   $country['alpha_2'] = strtoupper($country['alpha_2']);
   }
   if ($country['alpha_3'] && strlen($country['alpha_3']) != 3) {
	   $jTableResult['Result'] = "Error";
	   $jTableResult['Message'] = __("Incorrect alpha-3 code",'events-made-easy');
	   print json_encode($jTableResult);
	   wp_die();
   } else {
	   $country['alpha_3'] = strtoupper($country['alpha_3']);
   }
   if ($country['num_3'] && strlen($country['num_3']) != 3) {
	   $jTableResult['Result'] = "Error";
	   $jTableResult['Message'] = __("Incorrect num-3 code",'events-made-easy');
	   print json_encode($jTableResult);
	   wp_die();
   }

   if (current_user_can( get_option('eme_cap_settings'))) {
      if ($update)
         $res=eme_db_update_country($country['id'],$country);
      else
         $res=eme_db_insert_country($country);
      if (!$res) {
         $jTableResult['Result'] = "Error";
         if ($update)
            $jTableResult['Message'] = __('Update failed: ','events-made-easy');
         else
            $jTableResult['Message'] = __('Insert failed: ','events-made-easy');
      } else {
         $jTableResult['Result'] = "OK";
         if (!$update) {
            $record=eme_get_country($res);
            $jTableResult['Record'] = eme_esc_html($record);
         }
      }
   } else {
      $jTableResult['Result'] = "Error";
      $jTableResult['Message'] = __('Access denied!','events-made-easy');
   }

   //Return result to jTable
   print json_encode($jTableResult);
   wp_die();
}

function eme_ajax_state_edit() {
   check_ajax_referer('eme_countries','eme_admin_nonce');
   $jTableResult = array();

   if (isset($_POST['id'])) {
      $state=eme_get_state(intval($_POST['id']));
      $update=1;
      if (!$state) {
	      $jTableResult['Result'] = "Error";
	      $jTableResult['Message'] = __("No such state",'events-made-easy');
	      print json_encode($jTableResult);
	      wp_die();
      }
   } else {
      $state=eme_new_state();
      $update=0;
   }
   foreach ($state as $key=>$val) {
      if (isset($_POST[$key]))
         $state[$key]=eme_strip_tags($_POST[$key]);
   }
   if (strlen($state['code']) != 2) {
	   $jTableResult['Result'] = "Error";
	   $jTableResult['Message'] = __("Incorrect state code",'events-made-easy');
	   print json_encode($jTableResult);
	   wp_die();
   } else {
	   $state['code'] = strtoupper($state['code']);
   }
   if (!$state['country_id']) {
	   $jTableResult['Result'] = "Error";
	   $jTableResult['Message'] = __("Incorrect country selection",'events-made-easy');
	   print json_encode($jTableResult);
	   wp_die();
   }

   if (current_user_can( get_option('eme_cap_settings'))) {
      if ($update)
         $res=eme_db_update_state($state['id'],$state);
      else
         $res=eme_db_insert_state($state);
      if (!$res) {
         $jTableResult['Result'] = "Error";
         if ($update)
            $jTableResult['Message'] = __('Update failed: ','events-made-easy');
         else
            $jTableResult['Message'] = __('Insert failed: ','events-made-easy');
      } else {
         $jTableResult['Result'] = "OK";
         if (!$update) {
            $record=eme_get_state($res);
	    // for the new record, we also need to provide the locale (as done in eme_get_states)
            $record['locale']=eme_get_state_locale($res);
            $jTableResult['Record'] = eme_esc_html($record);
         }
      }
   } else {
      $jTableResult['Result'] = "Error";
      $jTableResult['Message'] = __('Access denied!','events-made-easy');
   }

   //Return result to jTable
   print json_encode($jTableResult);
   wp_die();
}

// some other ajax functions
function eme_select_state_ajax() {
   check_ajax_referer('eme_frontend','eme_nonce');
   $q = isset($_REQUEST['q']) ? eme_sanitize_request($_REQUEST['q']) : '';
   $country_code= isset($_POST['country_code'])? eme_sanitize_request($_POST['country_code']) : '';
   // the country code can be empty, in which case eme_get_localized_states will return states if only 1 country exists
   $records=array();
   $states = eme_get_localized_states($country_code);
   foreach ($states as $state) {
      if (!empty($q) && !stristr($state['name'],$q)) continue;
      $record = array();
      $record['id']= $state['code'];
      $record['text'] = $state['name'];
      $records[]  = $record;
   }
   $jTableResult['TotalRecordCount'] = count($records);
   $jTableResult['Records'] = $records;
   print json_encode($jTableResult);
}

function eme_select_country_ajax() {
   check_ajax_referer('eme_frontend','eme_nonce');
   $q = isset($_REQUEST['q']) ? eme_sanitize_request($_REQUEST['q']) : '';
   $records=array();
   $countries = eme_get_localized_countries();
   foreach ($countries as $country) {
      if (!empty($q) && !stristr($country['name'],$q)) continue;
      $record = array();
      $record['id']= $country['alpha_2'];
      $record['text'] = $country['name'];
      $records[]  = $record;
   }
   $jTableResult['TotalRecordCount'] = count($records);
   $jTableResult['Records'] = $records;
   print json_encode($jTableResult);
}

?>
